using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Threading;
using System.Windows.Forms;
using System.Data;

using QN.Basics;

using RG.Basics;
using RG.SQL;
using RG.XMLDB;

namespace QN.Stat {

	/// <summary>
	/// Summary description for frmStat.
	/// </summary>
	public class frmStat : System.Windows.Forms.Form {

		#region My Members

		private	CmpSelPresets m_CmpSelPresets;

		private int m_butActCRDT, m_butActIssDT, m_butActTRsDT, m_butCmpgnDT, m_butCRDT, m_butFxsDT, m_butIssDT, m_butTRsDT, m_tMonDH, m_tMonDW, m_txtStatDT, m_comboLogDT, m_comboLogDW;

		private QNGUIservice m_GUIservice;
		private QNphrase m_QNphrase;
		private QNpresets m_Presets;
		private QNTools m_QNTools;

		private static SimpleLog m_Logger;

		private string m_ApplPth;

        private string[] m_StrtArgs;

        private RGSQL2 m_DB;
		private XMLDB m_xDB;

		private QNStatTools m_StatTools;

		#endregion

		#region Form Members

		private System.Windows.Forms.TextBox txtStat;
		private System.Windows.Forms.ComboBox comboLog;
		private System.Windows.Forms.TextBox txtMonitor;
		private System.Windows.Forms.Button butCmpgn;
		private System.Windows.Forms.Button butTRs;
		private MenuStrip mainMenu;
		private ToolStripMenuItem menuHelp;
		private ToolStripMenuItem menuDocu;
		private ToolStripMenuItem menuAbout;
        private Button butFixs;
        private Button butActTRs;
        private Button butIss;
        private Button butActIss;
        private Button butActCR;
        private Button butCR;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#endregion

		#region Construction/Destruction

        // ------------------------
		public frmStat( string[] args ) {
			
			try {

				m_Logger = new SimpleLog( "StatUtil" );

				InitializeComponent();

				init();

                m_StrtArgs = args;
          
                if( m_StrtArgs.Length > 0 ) {

                    Thread strtThread = new Thread(new ThreadStart(autoStart));
				    strtThread.Start();
			    }
			}
			catch( Exception e ) {
		
				handleExcp( e );
			}
		}

        // ------------------------
		public void autoStart() {

            bool notHndl = true; 

            string dt;
            string run;

			SetList fileSpec;
            String txt;
			
			try {

                run = m_StrtArgs[0];

                //System.Threading.Thread.Sleep( 2000 );

				/* m_Logger = new SimpleLog( "StatUtil" );

				InitializeComponent();

				init(); */

                dt = BTools.getNowISODateTime();

                txt = "Autostart for " + run;

                m_Logger.write2Log( txt );

                txtMonitor.Text = txt;

                if( run.CompareTo( "AllCR" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "CR", ref dt );

                    getStat4CRs( fileSpec, dt, true );
                }
                else if( run.CompareTo( "ActCR" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "ActCR", ref dt );

                    getStat4CRs( fileSpec, dt, false );
                }
                else if( run.CompareTo( "AllFix" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "Fix", ref dt );

                    getStat4Fix( fileSpec, dt );
                }
                else if( run.CompareTo( "ActFix" ) == 0) {

                    /*
                    fileSpec = getOutFile( "Fix", ref dt );

                    getStat4CRs( fileSpec, dt, false );
                    */ 
                }
                else if( run.CompareTo( "AllTR" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "TR", ref dt );

                    getStat4TRs( fileSpec, dt, true );
                }
                else if( run.CompareTo( "ActTR" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "ActTR", ref dt );

                    getStat4TRs( fileSpec, dt, false );
                }
                else if( run.CompareTo( "AllIss" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "Iss", ref dt );

                    getStat4Iss( fileSpec, dt, true );
                }
                else if( run.CompareTo( "ActIss" ) == 0) {

                    notHndl = false;

                    fileSpec = getOutFile( "ActIss", ref dt );

                    getStat4Iss( fileSpec, dt, false );
                }
                /*
                else if( run.CompareTo( "Cmpgn" ) == 0) {

                    fileSpec = getOutFile( "Cmpgn", ref dt );

                    getStat4Cmpgn( fileSpec, dt );
                }*/

                if(notHndl)
                {
                    txtMonitor.Text = "Autostart for '" + run + "' is not supported.";
                    txtMonitor.Text += "\r\nSupported Modes: AllFix, AllTR, ActTR, AllCR, ActCR, AllIss, ActIss";
                }
                else
                {
                    System.Threading.Thread.Sleep( 10000 );
                    this.Close();
                    /*Thread closeThread = new Thread(new ThreadStart(autoClose));
				    closeThread.Start();*/
                }
			}
			catch( Exception e ) {
		
				handleExcp( e );
			}
		}

        private void getStat4Cmpgn( SetList fileSpec, string dt )
        {
            throw new NotImplementedException();
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
                //m_DB.close();
			}
			base.Dispose( disposing );
		}
		
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager( typeof( frmStat ) );
            this.txtMonitor = new System.Windows.Forms.TextBox();
            this.butCmpgn = new System.Windows.Forms.Button();
            this.txtStat = new System.Windows.Forms.TextBox();
            this.comboLog = new System.Windows.Forms.ComboBox();
            this.butTRs = new System.Windows.Forms.Button();
            this.mainMenu = new System.Windows.Forms.MenuStrip();
            this.menuHelp = new System.Windows.Forms.ToolStripMenuItem();
            this.menuDocu = new System.Windows.Forms.ToolStripMenuItem();
            this.menuAbout = new System.Windows.Forms.ToolStripMenuItem();
            this.butFixs = new System.Windows.Forms.Button();
            this.butActTRs = new System.Windows.Forms.Button();
            this.butIss = new System.Windows.Forms.Button();
            this.butActIss = new System.Windows.Forms.Button();
            this.butActCR = new System.Windows.Forms.Button();
            this.butCR = new System.Windows.Forms.Button();
            this.mainMenu.SuspendLayout();
            this.SuspendLayout();
            // 
            // txtMonitor
            // 
            this.txtMonitor.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( ( ( System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom )
                        | System.Windows.Forms.AnchorStyles.Left )
                        | System.Windows.Forms.AnchorStyles.Right ) ) );
            this.txtMonitor.Font = new System.Drawing.Font( "Lucida Console", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtMonitor.Location = new System.Drawing.Point( 5, 34 );
            this.txtMonitor.Multiline = true;
            this.txtMonitor.Name = "txtMonitor";
            this.txtMonitor.ReadOnly = true;
            this.txtMonitor.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.txtMonitor.Size = new System.Drawing.Size( 908, 201 );
            this.txtMonitor.TabIndex = 0;
            this.txtMonitor.TabStop = false;
            // 
            // butCmpgn
            // 
            this.butCmpgn.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butCmpgn.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butCmpgn.Location = new System.Drawing.Point( 11, 353 );
            this.butCmpgn.Name = "butCmpgn";
            this.butCmpgn.Size = new System.Drawing.Size( 178, 31 );
            this.butCmpgn.TabIndex = 1;
            this.butCmpgn.Text = "cmpgn";
            this.butCmpgn.MouseLeave += new System.EventHandler( this.butCmpgn_MouseLeave );
            this.butCmpgn.Click += new System.EventHandler( this.butCmpgn_Click );
            this.butCmpgn.MouseEnter += new System.EventHandler( this.butCmpgn_MouseEnter );
            // 
            // txtStat
            // 
            this.txtStat.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.txtStat.BackColor = System.Drawing.Color.Yellow;
            this.txtStat.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.txtStat.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.txtStat.Location = new System.Drawing.Point( 14, 396 );
            this.txtStat.MinimumSize = new System.Drawing.Size( 108, 24 );
            this.txtStat.Name = "txtStat";
            this.txtStat.ReadOnly = true;
            this.txtStat.Size = new System.Drawing.Size( 144, 26 );
            this.txtStat.TabIndex = 0;
            this.txtStat.TabStop = false;
            this.txtStat.Text = "Initializing...";
            this.txtStat.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // comboLog
            // 
            this.comboLog.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left )
                        | System.Windows.Forms.AnchorStyles.Right ) ) );
            this.comboLog.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboLog.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.comboLog.ItemHeight = 20;
            this.comboLog.Location = new System.Drawing.Point( 200, 396 );
            this.comboLog.Name = "comboLog";
            this.comboLog.Size = new System.Drawing.Size( 713, 28 );
            this.comboLog.TabIndex = 7;
            // 
            // butTRs
            // 
            this.butTRs.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butTRs.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butTRs.Location = new System.Drawing.Point( 11, 242 );
            this.butTRs.Name = "butTRs";
            this.butTRs.Size = new System.Drawing.Size( 178, 31 );
            this.butTRs.TabIndex = 2;
            this.butTRs.Text = "TRs";
            this.butTRs.MouseLeave += new System.EventHandler( this.butTRs_MouseLeave );
            this.butTRs.Click += new System.EventHandler( this.butTRs_Click );
            this.butTRs.MouseEnter += new System.EventHandler( this.butTRs_MouseEnter );
            // 
            // mainMenu
            // 
            this.mainMenu.Items.AddRange( new System.Windows.Forms.ToolStripItem[] {
            this.menuHelp} );
            this.mainMenu.Location = new System.Drawing.Point( 0, 0 );
            this.mainMenu.Name = "mainMenu";
            this.mainMenu.Size = new System.Drawing.Size( 925, 28 );
            this.mainMenu.TabIndex = 12;
            this.mainMenu.Text = "menuStrip1";
            // 
            // menuHelp
            // 
            this.menuHelp.DropDownItems.AddRange( new System.Windows.Forms.ToolStripItem[] {
            this.menuDocu,
            this.menuAbout} );
            this.menuHelp.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.menuHelp.Name = "menuHelp";
            this.menuHelp.Size = new System.Drawing.Size( 56, 24 );
            this.menuHelp.Text = "Help";
            // 
            // menuDocu
            // 
            this.menuDocu.Name = "menuDocu";
            this.menuDocu.Size = new System.Drawing.Size( 126, 24 );
            this.menuDocu.Text = "Docu";
            this.menuDocu.Click += new System.EventHandler( this.menuDocu_Click );
            // 
            // menuAbout
            // 
            this.menuAbout.Name = "menuAbout";
            this.menuAbout.Size = new System.Drawing.Size( 126, 24 );
            this.menuAbout.Text = "About";
            this.menuAbout.Click += new System.EventHandler( this.menuAbout_Click );
            // 
            // butFixs
            // 
            this.butFixs.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butFixs.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butFixs.Location = new System.Drawing.Point( 391, 242 );
            this.butFixs.Name = "butFixs";
            this.butFixs.Size = new System.Drawing.Size( 177, 31 );
            this.butFixs.TabIndex = 4;
            this.butFixs.Text = "fixes";
            this.butFixs.MouseLeave += new System.EventHandler( this.butFixs_MouseLeave );
            this.butFixs.Click += new System.EventHandler( this.butFixs_Click );
            this.butFixs.MouseEnter += new System.EventHandler( this.butFixs_MouseEnter );
            // 
            // butActTRs
            // 
            this.butActTRs.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butActTRs.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butActTRs.Location = new System.Drawing.Point( 200, 242 );
            this.butActTRs.Name = "butActTRs";
            this.butActTRs.Size = new System.Drawing.Size( 179, 31 );
            this.butActTRs.TabIndex = 3;
            this.butActTRs.Text = "aTRs";
            this.butActTRs.MouseLeave += new System.EventHandler( this.butActTRs_MouseLeave );
            this.butActTRs.Click += new System.EventHandler( this.butActTRs_Click );
            this.butActTRs.MouseEnter += new System.EventHandler( this.butActTRs_MouseEnter );
            // 
            // butIss
            // 
            this.butIss.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butIss.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butIss.Location = new System.Drawing.Point( 11, 317 );
            this.butIss.Name = "butIss";
            this.butIss.Size = new System.Drawing.Size( 177, 31 );
            this.butIss.TabIndex = 5;
            this.butIss.Text = "issues";
            this.butIss.MouseLeave += new System.EventHandler( this.butIss_MouseLeave );
            this.butIss.Click += new System.EventHandler( this.butIss_Click );
            this.butIss.MouseEnter += new System.EventHandler( this.butIss_MouseEnter );
            // 
            // butActIss
            // 
            this.butActIss.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butActIss.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butActIss.Location = new System.Drawing.Point( 200, 317 );
            this.butActIss.Name = "butActIss";
            this.butActIss.Size = new System.Drawing.Size( 177, 31 );
            this.butActIss.TabIndex = 6;
            this.butActIss.Text = "aIssues";
            this.butActIss.MouseLeave += new System.EventHandler( this.butActIss_MouseLeave );
            this.butActIss.Click += new System.EventHandler( this.butActIss_Click );
            this.butActIss.MouseEnter += new System.EventHandler( this.butActIss_MouseEnter );
            // 
            // butActCR
            // 
            this.butActCR.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butActCR.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butActCR.Location = new System.Drawing.Point( 200, 282 );
            this.butActCR.Name = "butActCR";
            this.butActCR.Size = new System.Drawing.Size( 177, 30 );
            this.butActCR.TabIndex = 14;
            this.butActCR.Text = "actCR";
            this.butActCR.MouseLeave += new System.EventHandler( this.butActCR_MouseLeave );
            this.butActCR.Click += new System.EventHandler( this.butActCR_Click );
            this.butActCR.MouseEnter += new System.EventHandler( this.butActCR_MouseEnter );
            // 
            // butCR
            // 
            this.butCR.Anchor = ( (System.Windows.Forms.AnchorStyles)( ( System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left ) ) );
            this.butCR.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.butCR.Location = new System.Drawing.Point( 11, 282 );
            this.butCR.Name = "butCR";
            this.butCR.Size = new System.Drawing.Size( 177, 30 );
            this.butCR.TabIndex = 13;
            this.butCR.Text = "cr";
            this.butCR.MouseLeave += new System.EventHandler( this.butCR_MouseLeave );
            this.butCR.Click += new System.EventHandler( this.butCR_Click );
            this.butCR.MouseEnter += new System.EventHandler( this.butCR_MouseEnter );
            // 
            // frmStat
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size( 8, 19 );
            this.ClientSize = new System.Drawing.Size( 925, 435 );
            this.Controls.Add( this.butActCR );
            this.Controls.Add( this.butCR );
            this.Controls.Add( this.butActIss );
            this.Controls.Add( this.butIss );
            this.Controls.Add( this.butActTRs );
            this.Controls.Add( this.butFixs );
            this.Controls.Add( this.butTRs );
            this.Controls.Add( this.comboLog );
            this.Controls.Add( this.txtStat );
            this.Controls.Add( this.txtMonitor );
            this.Controls.Add( this.butCmpgn );
            this.Controls.Add( this.mainMenu );
            this.Font = new System.Drawing.Font( "Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ( (byte)( 0 ) ) );
            this.Icon = ( (System.Drawing.Icon)( resources.GetObject( "$this.Icon" ) ) );
            this.MainMenuStrip = this.mainMenu;
            this.MinimumSize = new System.Drawing.Size( 933, 63 );
            this.Name = "frmStat";
            this.Text = "k";
            this.Load += new System.EventHandler( this.frmStat_Load );
            this.VisibleChanged += new System.EventHandler( this.frmStat_VisibleChanged );
            this.Resize += new System.EventHandler( this.frmStat_Resize );
            this.mainMenu.ResumeLayout( false );
            this.mainMenu.PerformLayout();
            this.ResumeLayout( false );
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main( string[] args ) {

            Application.Run(new frmStat( args ));
		}

		private void frmStat_Load(object sender, System.EventArgs e) {
		
		}

		#region Core

		// ---------------------
		private void cleanStr4Csv( ref string p_Str ) {

			p_Str = p_Str.Replace( ";", "," );
		}

        // ---------------------
        private void doResize()
        {
            /*
            int x, y;

            y = this.Height;
            x = this.Width;

            txtMonitor.Height = y - m_tMonDH;
            txtMonitor.Width = x - m_tMonDW;

            //txtStat.Top = y - m_txtStatDT;
            comboLog.Top = y - m_comboLogDT;
            comboLog.Width = x - m_comboLogDW;

            butActCR.Top = y - m_butCRDT;
            butActTRs.Top = y - m_butActTRsDT;
            butActIss.Top = y - m_butActIssDT;
            butCmpgn.Top = y - m_butCmpgnDT;
            butCR.Top = y - m_butCRDT;
            butFixs.Top = y - m_butFxsDT;
            butIss.Top = y - m_butIssDT;
            butTRs.Top = y - m_butTRsDT;
            */
        }

		// ---------------------
		private void doIssueStats( string p_Msg, string p_FileNameFrag, SetList p_FileSpec, QNStatData p_StatData ) {

			string fileName;

			txtMonitor.Text += "\r\n" + p_Msg + ":";

			fileName = p_FileSpec[0] + p_FileNameFrag + p_FileSpec[1];

			issueStats( p_StatData, ref fileName );

			txtMonitor.Text += "\r\n->" + fileName;
			txtMonitor.Refresh();
		}

        		// -------------------------------
		private SetList getOutFile( string p_FileName, ref string p_DateTime  ) {

			SetList fileSpec = new SetList();

			string fName = m_Presets.m_StatsPth + "\\" + m_QNTools.clearFileName( p_FileName + "-Stats-" + p_DateTime.Replace(":","") );

            fileSpec.Add( fName );

            fileSpec.Add( ".txt" );

			return fileSpec;
		}

		// ------------------------------------
		private void getStat4Cmpgn( string p_CmpgnName, string p_CmpgnID, SetList p_FileSpec, string p_DateTime ) {

			QNStatData cmpgnData = new QNStatData( m_xDB );
			QNStatData tcData = new QNStatData( m_xDB );
			QNStatData tc2ReqData = new QNStatData( m_xDB );
			QNStatData tcSetData = new QNStatData( m_xDB );
			QNStatData tcExData = new QNStatData( m_xDB );
			QNStatData prData = new QNStatData( m_xDB );

			Rslt res;

            res = m_DB.recycle();

            if(res.isOK())
            {

                txtMonitor.Text = p_FileSpec[0] + p_FileSpec[1];
                txtMonitor.Text += "\r\nGenerated " + p_DateTime;

                txtMonitor.Text += "\r\n\r\nRetrieving data ...";
                txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();

                res = m_StatTools.genStat4Cmpgn( p_CmpgnID, cmpgnData, tcSetData, tcData, tc2ReqData, tcExData, prData, ref p_DateTime );
            }

			if( res.isOK() ) {

                txtMonitor.Text += "\r\n\r\nWriting Campaign data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();

				doIssueStats( "Campaign", "-Cmpgn", p_FileSpec, cmpgnData );

                txtMonitor.Text += "\r\n\r\nWriting TC Set data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();

				doIssueStats( "TC Sets", "-TCSets", p_FileSpec, tcSetData );

                txtMonitor.Text += "\r\n\r\nWriting TC data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();
				doIssueStats( "Test Cases", "-TCs", p_FileSpec, tcData );

                txtMonitor.Text += "\r\n\r\nWriting test-to-requirements data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();
				doIssueStats( "Test 2 Requirements", "-TC2Req", p_FileSpec, tc2ReqData );

                txtMonitor.Text += "\r\n\r\nWriting TC Exec data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();
				doIssueStats( "Test Executions", "-TCEx", p_FileSpec, tcExData );

                txtMonitor.Text += "\r\n\r\nWriting TR data ...";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();
				doIssueStats( "Problem Reports:", "-TRs", p_FileSpec, prData );

                txtMonitor.Text += "\r\n\r\nDone.";
txtMonitor.Text += BTools.getNowISODateTime();
                txtMonitor.Refresh();
				setAppStat( AppStat.OK );

				addLog( String.Format( m_QNphrase.msgStatsGen, p_CmpgnName ) );
			}
			else {
		
				handleErr( res, m_QNphrase.errStatGenFailed );
			}
		}

		// ------------------------------------
		private void getStat4CRs( SetList p_FileSpec, string p_DateTime, bool p_All ) {

			QNStatData data = new QNStatData( m_xDB );
            QNStatData log = new QNStatData( m_xDB );

            Rslt res;

            res = m_DB.recycle();

            if(res.isOK())
            {
                txtMonitor.Text = p_FileSpec[0] + p_FileSpec[1];
                txtMonitor.Text += "\r\nGenerated " + p_DateTime + ".";

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
                txtMonitor.Text += "\r\n\r\nRetrieving data ...";

                txtMonitor.Refresh();

                res = m_StatTools.genStat4CR( data, log, ref p_DateTime, p_All );
            }

			if( res.isOK() ) {

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
				txtMonitor.Text += "\r\n\r\nWrinting data ...";

                txtMonitor.Refresh();
				//txtMonitor.Text += "\r\nExcluding closed Problem Reports.";

				// ---
				//fileName = p_FileSpec[0] + p_FileSpec[1];

				//issueStats( data, ref fileName );

                doIssueStats( "CR Data", "-Data", p_FileSpec, data );

                txtMonitor.Text += "\r\n\r\nWrinting log ...";

                txtMonitor.Refresh();
                doIssueStats( "CR Log", "-Log", p_FileSpec, log );

				//txtMonitor.Text += "\r\n->" + fileName;

				setAppStat( AppStat.OK );

                txtMonitor.Text += "\r\n\r\nDone.";

				addLog( String.Format( m_QNphrase.msgStatsGen, m_QNphrase.msgCRs ) );
			}
			else {
	
				handleErr( res, m_QNphrase.errStatGenFailed );
			}
		}

		// ------------------------------------
		private void getStat4Fix( SetList p_FileSpec, string p_DateTime ) {

			QNStatData fxData = new QNStatData( m_xDB );
            QNStatData files = new QNStatData( m_xDB );

			Rslt res;

			//string fileName; 2008-12-23

            res = m_DB.recycle();

            if(res.isOK())
            {

                txtMonitor.Text = p_FileSpec[0] + p_FileSpec[1];
                txtMonitor.Text += "\r\nGenerated " + p_DateTime + ".";

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
                txtMonitor.Text += "\r\n\r\nRetrieving data ...";

                txtMonitor.Refresh();

                res = m_StatTools.genStat4Fix( fxData, files, ref p_DateTime );
            }

			if( res.isOK() ) {

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
				txtMonitor.Text += "\r\n\r\nWrinting data ...";

                txtMonitor.Refresh();
				//txtMonitor.Text += "\r\nExcluding closed Problem Reports.";

				// ---
				//fileName = p_FileSpec[0] + p_FileSpec[1];

				//issueStats( prData, ref fileName );

                doIssueStats( "Fix Data", "-Data", p_FileSpec, fxData );

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
                txtMonitor.Text += "\r\n\r\nWrinting files information ...";

                txtMonitor.Refresh();
                doIssueStats( "Fix Files", "-Files", p_FileSpec, files );

				//txtMonitor.Text += "\r\n->" + fileName;

				setAppStat( AppStat.OK );

                txtMonitor.Text += "\r\n\r\nDone.";

				addLog( String.Format( m_QNphrase.msgStatsGen, m_QNphrase.msgFxs ) );
			}
			else {
	
				handleErr( res, m_QNphrase.errStatGenFailed );
			}
		}

        // ------------------------------------
		private void getStat4Iss( SetList p_FileSpec, string p_DateTime, bool p_All ) {

			QNStatData data = new QNStatData( m_xDB );
            QNStatData log = new QNStatData( m_xDB );

			Rslt res;

			//string fileName; 2008-12-23
            res = m_DB.recycle();

            if(res.isOK())
            {
                txtMonitor.Text = p_FileSpec[0] + p_FileSpec[1];
                txtMonitor.Text += "\r\nGenerated " + p_DateTime + ".";

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
                txtMonitor.Text += "\r\n\r\nRetrieving data ...";

                txtMonitor.Refresh();

                res = m_StatTools.genStat4Iss( data, log, ref p_DateTime, p_All );
            }

			if( res.isOK() ) {

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
				txtMonitor.Text += "\r\n\r\nWrinting data ...";

                txtMonitor.Refresh();

                doIssueStats( "Iss Data", "-Data", p_FileSpec, data );

                txtMonitor.Text += "\r\n\r\nWrinting log ...";

                txtMonitor.Refresh();
                doIssueStats( "Iss Log", "-Log", p_FileSpec, log );

				//txtMonitor.Text += "\r\n->" + fileName;

				setAppStat( AppStat.OK );

                txtMonitor.Text += "\r\n\r\nDone.";

				addLog( String.Format( m_QNphrase.msgStatsGen, m_QNphrase.msgIsss ) );
			}
			else {
	
				handleErr( res, m_QNphrase.errStatGenFailed );
			}
		}

		// ------------------------------------
		private void getStat4TRs( SetList p_FileSpec, string p_DateTime, bool p_All ) {

			QNStatData data = new QNStatData( m_xDB );
            QNStatData log = new QNStatData( m_xDB );

			Rslt res;

			//string fileName; 2008-12-23
            res = m_DB.recycle();

            if(res.isOK())
            {
                txtMonitor.Text = p_FileSpec[0] + p_FileSpec[1];
                txtMonitor.Text += "\r\nGenerated " + p_DateTime + ".";

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
                txtMonitor.Text += "\r\n\r\nRetrieving data ...";

                txtMonitor.Refresh();

                res = m_StatTools.genStat4TRs( data, log, ref p_DateTime, p_All );
            }

			if( res.isOK() ) {

                txtMonitor.Text += "\r\n\r\n" + BTools.getNowISODateTime();
				txtMonitor.Text += "\r\n\r\nWrinting data ...";

                txtMonitor.Refresh();
				//txtMonitor.Text += "\r\nExcluding closed Problem Reports.";

				// ---
				//fileName = p_FileSpec[0] + p_FileSpec[1];

				//issueStats( data, ref fileName );

                doIssueStats( "TR Data", "-Data", p_FileSpec, data );

                txtMonitor.Text += "\r\n\r\nWrinting log ...";

                txtMonitor.Refresh();
                doIssueStats( "TR Log", "-Log", p_FileSpec, log );

				//txtMonitor.Text += "\r\n->" + fileName;

				setAppStat( AppStat.OK );

                txtMonitor.Text += "\r\n\r\nDone.";

				addLog( String.Format( m_QNphrase.msgStatsGen, m_QNphrase.msgTRs ) );
			}
			else {
	
				handleErr( res, m_QNphrase.errStatGenFailed );
			}
		}

		// -----------------------------
		private void issueStats( QNStatData p_Data, ref string p_FileName ) {
			
			int dPos, x;

			FileStream fs = new FileStream( p_FileName, FileMode.CreateNew, FileAccess.Write, FileShare.None );

			//StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.UTF8); Not properly processesd by Excel
			StreamWriter sw = new StreamWriter( fs, System.Text.Encoding.ASCII );

			//txtMonitor.Text += "\r\n";

			dPos = issueStatsHeader( p_Data.theAttrs, sw );

			x = p_Data.theAddAttrs.Count;

			if( x > 0 ) {
				
				//txtMonitor.Text += " | ";

				sw.Write( ";" );

				issueStatsHeader( p_Data.theAddAttrs, sw );
			}

			if( x > 0 ) {

				issueStatsData( p_Data.theAttrs, dPos, p_Data.theAddAttrs, sw );
			}
			else {

				issueStatsData( p_Data.theAttrs, dPos, sw );
			}

			sw.Close();
		}

		// -----------------------------
		private void issueStatsData( RsltTable p_AttrLst, int p_dPos, StreamWriter p_SW ) {
			
			int i, j, y, x;

			string txt;

			x = p_AttrLst.getRowNum();
			y = p_AttrLst.getColSize();

			for( i = 0; i < x; i++) {

				//txtMonitor.Text += "\r\n";
				p_SW.WriteLine();

				if( y > 0 ) {

					// if( "DateTime" == p_AttrLst.getCell(0, j) ) {
					if( 0 == p_dPos ) {

						txt = BTools.getDateFromISODateTime( p_AttrLst.getCell(0, i) );

						cleanStr4Csv( ref txt );

						//txtMonitor.Text += txt;

						p_SW.Write( txt );

						txt = BTools.getTimeFromISODateTime( p_AttrLst.getCell(0, i) );

						cleanStr4Csv( ref txt );

						//txtMonitor.Text += " | " + txt;
						//txtMonitor.Text += ".";
						//txtMonitor.Refresh();

						p_SW.Write( ";" + txt );
					}
					else {

						txt = p_AttrLst.getCell(0, i);

						cleanStr4Csv( ref txt );

						p_SW.Write( txt );

						//txtMonitor.Text += txt;
						//txtMonitor.Text += ".";
						//txtMonitor.Refresh();
					}
				}

				for( j = 1; j < y; j++) {

					// if( "DateTime" == p_AttrLst.getCell(0, j) ) {
					if( j == p_dPos ) {

						txt = BTools.getDateFromISODateTime( p_AttrLst.getCell(j, i) );

						cleanStr4Csv( ref txt );

						//txtMonitor.Text += " | " + txt;
						//txtMonitor.Text += ".";
						//txtMonitor.Refresh();

						p_SW.Write( ";" + txt );

						txt = BTools.getTimeFromISODateTime( p_AttrLst.getCell(j, i) );
					}
					else {

						txt = p_AttrLst.getCell(j, i);
					}

					cleanStr4Csv( ref txt );

					//txtMonitor.Text += " | " + txt;

					p_SW.Write( ";" + txt );
				}
			}
		}

		// -----------------------------
		public void issueStatsData( RsltTable p_AttrLst, int p_dPos, RsltTable p_AddAttrLst, StreamWriter p_SW ) {
			
			int i, j, y, x, z;

			string txt;

			x = p_AttrLst.getRowNum();
			y = p_AttrLst.getColSize();

			z = p_AddAttrLst.getColSize();

			for( i = 0; i < x; i++) {

				//txtMonitor.Text += "\r\n";
				p_SW.WriteLine();

				if( y > 0 ) {

					// if( "DateTime" == p_AttrLst.getCell(0, j) ) {
					if( 0 == p_dPos ) {

						txt = BTools.getDateFromISODateTime( p_AttrLst.getCell(0, i) );
						
						cleanStr4Csv( ref txt );

						//txtMonitor.Text += txt;

						p_SW.Write( txt );

						txt = BTools.getTimeFromISODateTime( p_AttrLst.getCell(0, i) );

						cleanStr4Csv( ref txt );

						//txtMonitor.Text += " | " + txt;

						p_SW.Write( ";" + txt );
					}
					else {

						txt = p_AttrLst.getCell(0, i);

						cleanStr4Csv( ref txt );

						//txtMonitor.Text += txt;
                        //txtMonitor.Text += ".";
						//txtMonitor.Refresh();

						p_SW.Write( txt );
					}
				}

				for( j = 1; j < y; j++) {

					// if( "DateTime" == p_AttrLst.getCell(0, j) ) {
					if( j == p_dPos ) {

						txt = BTools.getDateFromISODateTime( p_AttrLst.getCell(j, i) );
					
						cleanStr4Csv( ref txt );

						//txtMonitor.Text += " | " + txt;

						p_SW.Write( ";" + txt );

						txt = BTools.getTimeFromISODateTime( p_AttrLst.getCell(j, i) );
					}
					else {

						txt = p_AttrLst.getCell(j, i);
					}
					
					cleanStr4Csv( ref txt );

					//txtMonitor.Text += " | " + txt;
                    //txtMonitor.Text += ".";
					//txtMonitor.Refresh();

					p_SW.Write( ";" + txt );
				}

				for( j = 0; j < z; j++) {

					txt = p_AddAttrLst.getCell(j, i);
										
					cleanStr4Csv( ref txt );

					//txtMonitor.Text += " | " + txt;
                    //txtMonitor.Text += ".";
					//txtMonitor.Refresh();

					p_SW.Write( ";" + txt );
				}
			}
		}

		// -----------------------------
		private int issueStatsHeader( RsltTable p_AttrLst, StreamWriter p_SW ) {

			int i, x;
			int dPos;

			string txt;

			dPos = 9999;

			x = p_AttrLst.getColSize();

			if( x > 0 ) {

				if( "DateTime" == p_AttrLst.getColName(0) ) {

					dPos = 0;

					txt = "Date";

					//txtMonitor.Text += txt;

					p_SW.Write( txt );

					txt = "Time";

					//txtMonitor.Text += " | " + txt;

					p_SW.Write( ";" + txt );
				}
				else {

					txt = p_AttrLst.getColName(0);

					//txtMonitor.Text += txt;

					p_SW.Write( txt );
				}
			}
				
			for( i = 1; i < x; i++) {

				if( "DateTime" == p_AttrLst.getColName(i) ) {

					dPos = i;

					txt = "Date";

					//txtMonitor.Text += " | " + txt;

					p_SW.Write( ";" + txt );

					txt = "Time";
				}
				else {

					txt = p_AttrLst.getColName(i);
				}

				//txtMonitor.Text += " | " + txt;

				p_SW.Write( ";" + txt );
			}

			return dPos;
		}

		#endregion

		#region My Stuff

        // --------------------------------
        private void autoClose()
        {
            System.Threading.Thread.Sleep( 10000 );
            this.Close();
        }
			
		//-------------------------------------------------------------------------					
		private void addLog( IRslt p_Res ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Res.getRsltLastMsg();

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( ref p_Res );

			comboLog.SelectedIndex = ix;
		}

		//-------------------------------------------------------------------------					
		private void addLog( string p_Msg ) {

			int ix;

			string msg = BTools.getNowISOTime() + " " + p_Msg;

			ix = comboLog.Items.Add( msg );

			m_Logger.write2Log( msg );

			comboLog.SelectedIndex = ix;
		}

		//----------------------
		private void handleErr( IRslt p_Res, string p_Msg ) {

			setAppStat( AppStat.Error );

			m_Logger.write2Log( ref p_Res );

			addLog( p_Msg );

			issueErr( p_Msg );
		}

		//-----------------------
		private void handleIfErr( IRslt p_Res, string p_Msg ) {

			if( p_Res.notOK() ) {

				handleErr( p_Res, p_Msg );
			}
		}
			
		//----------------------------
		private void handleExcp( Exception p_Excp ) {
				
			try {

				setAppStat( AppStat.Error );

				addLog( "Exception '" + p_Excp.Message + "'");

				m_Logger.write2Log( ref p_Excp );

				m_GUIservice.dispExcp( p_Excp );
			}
			catch {

				string msg = "An exception has occured at a very early stage of the"
				+ " initialization of the program. So early that the program is not able"
				+ " to provide you any aid. Errors at this stage are mostly due to"
				+ " bad configuration. If the configuration has been changed recently,"
				+ " switch back to the former version, if you can. In other cases please"
				+ " refer to the list of known problems in your documentation.";

				MessageBox.Show(  msg, "Early Error Occured", MessageBoxButtons.OK, MessageBoxIcon.Error );
			}
		}
			
		// -----------------------------
		/// <summary>
		/// Displays a text dialog. Detects, if the dialog is supposed to allow editing.
		/// If so, the Rslt is written back to p_Sender. 
		/// </summary>
		/// <param name="p_Sender"></param>
		/// <param name="p_Title"></param>
		private void handleTxtPop( object p_Sender, string p_Title ) {

			try {

				bool forEdit;
				DialogResult dRes;
				TextBox tBox;

				tBox = (TextBox)p_Sender;
							
				forEdit = !(tBox.ReadOnly);
						
				setAppStat( AppStat.Proc );

				frmTxtWin txtWin;
					
				txtWin = new frmTxtWin( forEdit, ref m_Presets );

				txtWin.Text = p_Title;

				txtWin.setText( tBox.Text );

				txtWin.TopMost = true;

				dRes = txtWin.ShowDialog();

				if( DialogResult.OK == dRes ) {

					if( forEdit ) {

						tBox.Text = txtWin.m_Text;
					}

					setAppStat( AppStat.OK );
				}

				txtWin.Dispose();

				setAppStat( AppStat.OK );
			}
			catch( Exception excp ) {
						
				handleExcp( excp );
			}	
		}
		
		// -----------------------------------
		private Rslt init() {

		    frmStat.CheckForIllegalCrossThreadCalls = false;

			int x, y;

			x = this.Width;
			y = this.Height;	

			// resizing stuff
			m_tMonDH = y - txtMonitor.Height;
			m_tMonDW = x - txtMonitor.Width;

			m_txtStatDT = y - txtStat.Top;
			m_comboLogDT = y - comboLog.Top;
			m_comboLogDW = x - comboLog.Width;

            m_butActIssDT = y - butActIss.Top;
            m_butActTRsDT = y - butActTRs.Top;
			m_butCmpgnDT = y - butCmpgn.Top;
            m_butCRDT = y - butCR.Top;
            m_butActCRDT = y - butActCR.Top;
			m_butFxsDT = y - butFixs.Top;
            m_butIssDT = y - butIss.Top;
            m_butTRsDT = y - butTRs.Top;
				
			Rslt res = new Rslt( RsltStatVal.isOK );

			m_QNTools = new QNTools();

			m_QNphrase = m_QNTools.m_QNphrase;
				
			m_GUIservice = new QNGUIservice( m_QNphrase );

			m_ApplPth = m_QNTools.getApplPth();

			m_Presets = new QNpresets( m_QNTools );

			setClrs();

			m_Logger.write2Log( m_QNTools.getApplInfo() );

			setLabels();

			if( m_Presets.notOK() ) {

				res.setRsltStat( m_Presets, m_QNphrase.errPresetFrm );
			}
			else {
					
				m_CmpSelPresets = new CmpSelPresets( m_Presets.m_Author );

                m_DB = new RGSQL2( m_Presets.m_DBloc, m_Presets.m_DBname, m_Presets.m_DBuser, m_Presets.m_DBpw );

				if( res.checkRslt( m_DB ) ) {

    				m_xDB = new XMLDB( m_DB, m_Presets.m_UIDsrvLoc );

					m_StatTools = new QNStatTools( m_xDB );
				}
			}
				
			if( res.isOK() ) {

				setAppStat( AppStat.OK );

				addLog( BTools.getNowISODate() + " " + m_QNphrase.msgSesStart );
			}

			handleIfErr( res, m_QNphrase.errInitFailed );

            doResize();

			return res;
		}

		//------------------------------
		private void issueErr( string msg ) {

			MessageBox.Show( msg, m_QNphrase.lblErr, MessageBoxButtons.OK, MessageBoxIcon.Error );
		}

		//---------------------------
		private void setAppStat( AppStat p_Stat ) {

			switch( p_Stat) {

				case AppStat.OK:

					txtStat.BackColor = m_Presets.m_ClrStatOK;
					txtStat.ForeColor = Color.White;
					txtStat.Text = m_QNphrase.lblOK;
				break;

				case AppStat.Proc:

					txtStat.BackColor = m_Presets.m_ClrStatProc;
					txtStat.ForeColor = Color.Black;
					txtStat.Text = m_QNphrase.lblProcng;
				break;

				case AppStat.Error:

					txtStat.BackColor = m_Presets.m_ClrStatErr;
					txtStat.ForeColor = Color.White;
					txtStat.Text =  m_QNphrase.lblErr;
				break;
			}

			this.Refresh();			
		}

		//---------------------------------
		private void setAppStatOK( bool p_IsOK ) {

			if( p_IsOK ) {

				setAppStat( AppStat.OK );
			}
			else {

				setAppStat( AppStat.Error );
			}
		}

		//---------------------------
		private void setClrs() {

			this.BackColor = m_Presets.m_ClrPnlBck;		
			this.ForeColor = m_Presets.m_ClrPnlFor;

            butActCR.BackColor = m_Presets.m_ClrButBck;
			butActCR.ForeColor = m_Presets.m_ClrPnlFor;

            butActIss.BackColor = m_Presets.m_ClrButBck;
			butActIss.ForeColor = m_Presets.m_ClrPnlFor;

            butActTRs.BackColor = m_Presets.m_ClrButBck;
			butActTRs.ForeColor = m_Presets.m_ClrPnlFor;

			butFixs.BackColor = m_Presets.m_ClrButBck;
			butFixs.ForeColor = m_Presets.m_ClrPnlFor;

			butCmpgn.BackColor = m_Presets.m_ClrButBck;
			butCmpgn.ForeColor = m_Presets.m_ClrPnlFor;

			butCR.BackColor = m_Presets.m_ClrButBck;
			butCR.ForeColor = m_Presets.m_ClrPnlFor;

			butIss.BackColor = m_Presets.m_ClrButBck;
			butIss.ForeColor = m_Presets.m_ClrPnlFor;

			butTRs.BackColor = m_Presets.m_ClrButBck;
			butTRs.ForeColor = m_Presets.m_ClrPnlFor;

			comboLog.BackColor = m_Presets.m_ClrTxtBck;

			txtMonitor.BackColor = m_Presets.m_ClrTxtBck;

		}

		// -------------------------------
		private SetList selectOutFile( string p_FileName, ref string p_DateTime  ) {

			SetList fileSpec = new SetList();

			int l;

			SaveFileDialog saveFileDial;
			saveFileDial = new SaveFileDialog();

			saveFileDial.Title = m_Presets.m_QNphrase.lblGenStat;

			/* Bug in Excel: is unable to import csvs properly, so we export the data as .txt
			saveFileDial.DefaultExt = "csv";
			saveFileDial.Filter = "CSV (*.csv)|*.csv"; */
			saveFileDial.DefaultExt = "txt";
			saveFileDial.Filter = "TXT (*.txt)|*.txt"; 
			saveFileDial.FilterIndex = 1 ;

			string fName = m_QNTools.clearFileName( p_FileName + "-Stats-" + p_DateTime.Replace(":","") );

			saveFileDial.FileName = fName;

			string pName = m_Presets.m_StatsPth;

			saveFileDial.InitialDirectory = pName;

			saveFileDial.RestoreDirectory = true;
			
			DialogResult dRes = saveFileDial.ShowDialog();

            if(dRes == DialogResult.OK)
            {

                l = saveFileDial.FileName.Length;

                fileSpec.Add( saveFileDial.FileName.Substring( 0, l - 4 ) );

                fileSpec.Add( saveFileDial.FileName.Substring( l - 4, 4 ) );

                saveFileDial.Dispose();
            }
            else
            {

                setAppStat( AppStat.OK );
            }

			return fileSpec;
		}

		#endregion
				
		#region I18N

		//---------------------------------
		private void setLabels() {

			Text = m_QNphrase.lblQANav + " " + m_QNphrase.lblStatGen;

            butFixs.Text = m_QNphrase.blblFixs;

			butCmpgn.Text = m_QNphrase.blblCmpgn;

			butCR.Text = m_QNphrase.blblCR;
            butActCR.Text = m_QNphrase.blblActCR;

            butIss.Text = m_QNphrase.blblIssues;
            butActIss.Text = m_QNphrase.blblActIssues;

			butTRs.Text = m_QNphrase.blblTRs;
            butActTRs.Text = m_QNphrase.blblActTRs;

			menuAbout.Text = m_QNphrase.mlblAbout;
			menuDocu.Text = m_QNphrase.mlblDocu;
			menuHelp.Text = m_QNphrase.mlblHelp;
		}

		#endregion

		#region Events

		// -----------------------
		private void butCmpgn_Click(object sender, System.EventArgs e) {
			
			try {

				DataLst RsltLst;

				DatLstEntry entry;

				int x;

				string dt;

				SetList fileSpec;

				dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				frmCmpSel dialCmpSel = new frmCmpSel( m_xDB, true, m_Presets, m_Presets.m_CmpgnStatLst, m_CmpSelPresets );

				DialogResult dRes = dialCmpSel.ShowDialog();

				if( DialogResult.Cancel == dRes ) {

					setAppStat( AppStat.OK );
				}
				else {

					RsltLst = dialCmpSel.m_RsltLst;

					x = RsltLst.Count;

					if( x < 1 ) {

						dialCmpSel.Dispose();

						setAppStat( AppStat.OK );
					}
					else {

						entry = RsltLst[0];

						dialCmpSel.Dispose();

						fileSpec = selectOutFile( entry.label, ref dt );

						if( fileSpec.isOK() ) {

							getStat4Cmpgn( entry.label, entry.val, fileSpec, dt );
						}
					}
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
		}

		// ---------------
		private void butCmpgn_MouseEnter(object sender, System.EventArgs e) {
			
			butCmpgn.BackColor = m_Presets.m_ClrButHigh;
		}

		// ---------------
		private void butCmpgn_MouseLeave(object sender, System.EventArgs e) {
		
			butCmpgn.BackColor = m_Presets.m_ClrButBck;
		}

		// ---------------
		private void butTRs_MouseEnter(object sender, System.EventArgs e) {
			
			butTRs.BackColor = m_Presets.m_ClrButHigh;
		}

		// ---------------
		private void butTRs_MouseLeave(object sender, System.EventArgs e) {
		
			butTRs.BackColor = m_Presets.m_ClrButBck;
		}

		// ---------------
		private void frmStat_Resize(object sender, System.EventArgs e) {

            doResize();
		}

		// ---------------
		private void butTRs_Click(object sender, System.EventArgs e) {
			
			try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "TR", ref dt );

				if( fileSpec.isOK() ) {

					getStat4TRs( fileSpec, dt, true );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}		
		}

		#endregion

		// ----------------------------------------
		private void menuDocu_Click( object sender, EventArgs e )
		{
			try
			{

				setAppStat( AppStat.Proc );

				System.Diagnostics.Process proc = new System.Diagnostics.Process();

				proc.EnableRaisingEvents = false;

				proc.StartInfo.FileName = QNDefs.manQN;

				proc.Start();

				setAppStat( AppStat.OK );
			}
			catch(Exception excp)
			{

				handleExcp( excp );
			}
		}

		// ----------------------------------------
		private void menuAbout_Click( object sender, EventArgs e )
		{
			string title;
			string msg;

			setAppStat( AppStat.Proc );

			title = String.Format( m_QNphrase.msgAbout, m_QNphrase.lblStatGen );

			msg = m_QNTools.getAboutInfoBlock();

			MessageBox.Show( msg, title, MessageBoxButtons.OK );

			setAppStat( AppStat.OK );
		}

        // --------------------
        private void butFixs_Click( object sender, EventArgs e )
        {

            try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "Fix", ref dt );

				if( fileSpec.isOK() ) {

					getStat4Fix( fileSpec, dt );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}	

        }

        // --------------
        private void butFixs_MouseEnter( object sender, EventArgs e )
        {
            butFixs.BackColor = m_Presets.m_ClrButHigh;
        }

        // --------------
        private void butFixs_MouseLeave( object sender, EventArgs e )
        {
            butFixs.BackColor = m_Presets.m_ClrButBck;
        }

        // --------------
        private void butActTRs_Click( object sender, EventArgs e )
        {
			try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "ActTR", ref dt );

				if( fileSpec.isOK() ) {

					getStat4TRs( fileSpec, dt, false );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
        }

        // --------------
        private void butActTRs_MouseEnter( object sender, EventArgs e )
        {
            butActTRs.BackColor = m_Presets.m_ClrButHigh;
        }

        // --------------
        private void butActTRs_MouseLeave( object sender, EventArgs e )
        {
            butActTRs.BackColor = m_Presets.m_ClrButBck;
        }

        // --------------
        private void butIss_MouseEnter( object sender, EventArgs e )
        {
            butIss.BackColor = m_Presets.m_ClrButHigh;
        }

        // --------------
        private void butIss_MouseLeave( object sender, EventArgs e )
        {
            butIss.BackColor = m_Presets.m_ClrButBck;
        }

        // --------------
        private void butIss_Click( object sender, EventArgs e )
        {
			try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "Iss", ref dt );

				if( fileSpec.isOK() ) {

					getStat4Iss( fileSpec, dt, true );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
        }

        // -----------------------------------
        private void butActIss_MouseEnter( object sender, EventArgs e )
        {
            butActIss.BackColor = m_Presets.m_ClrButHigh;
        }

        // --------------
        private void butActIss_MouseLeave( object sender, EventArgs e )
        {
            butActIss.BackColor = m_Presets.m_ClrButBck;
        }

        // --------------
        private void butActIss_Click( object sender, EventArgs e )
        {
           try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "ActIss", ref dt );

				if( fileSpec.isOK() ) {

					getStat4Iss( fileSpec, dt, false );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
        }

        // --------------
        // required to adapt to DPI-Settings other than standard.
        private void frmStat_VisibleChanged( object sender, EventArgs e )
        {
            doResize();
        }

        //----------------------------
        private void butCR_Click( object sender, EventArgs e )
        {

			try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "CR", ref dt );

				if( fileSpec.isOK() ) {

                    //Thread loadThread = new Thread(new ThreadStart(loadTCloader));
				    // Start the thread.
					//loadThread.Start();

					getStat4CRs( fileSpec, dt, true );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
        }

        // ----------------------------
        private void butActCR_Click( object sender, EventArgs e )
        {

			try {

				string dt;

				SetList fileSpec;

                dt = BTools.getNowISODateTime();
				
				setAppStat( AppStat.Proc );

				fileSpec = selectOutFile( "CR", ref dt );

				if( fileSpec.isOK() ) {

                    //Thread loadThread = new Thread(new ThreadStart(loadTCloader));
				    // Start the thread.
					//loadThread.Start();

					getStat4CRs( fileSpec, dt, false );
				}
			}
			catch( Exception excp ) {
					
				handleExcp( excp );
			}
        }

        // -----------------------------------
        private void butCR_MouseEnter( object sender, EventArgs e )
        {
            butCR.BackColor = m_Presets.m_ClrButHigh;
        }

        // -----------------------------------
        private void butCR_MouseLeave( object sender, EventArgs e )
        {
            butCR.BackColor = m_Presets.m_ClrButBck;
        }

        // -----------------------------------
        private void butActCR_MouseEnter( object sender, EventArgs e )
        {
            butActCR.BackColor = m_Presets.m_ClrButHigh;
        }

        // -----------------------------------
        private void butActCR_MouseLeave( object sender, EventArgs e )
        {
            butActCR.BackColor = m_Presets.m_ClrButBck;
        }
	}
}
